Index: protocols/oscar/oscar.c
===================================================================
--- protocols/oscar/oscar.c	(revision 8519f457c31139750b9f7497834ac90a57196d22)
+++ protocols/oscar/oscar.c	(revision 75ad761cc229568e799659d6c6a623c4bc837ba4)
@@ -1186,24 +1255,23 @@
 
 	switch (channel) {
-		case 1: { /* standard message */
-			struct aim_incomingim_ch1_args *args;
-			args = va_arg(ap, struct aim_incomingim_ch1_args *);
-			ret = incomingim_chan1(sess, fr->conn, userinfo, args);
-		} break;
-
-		case 2: { /* rendevous */
-			struct aim_incomingim_ch2_args *args;
-			args = va_arg(ap, struct aim_incomingim_ch2_args *);
-			ret = incomingim_chan2(sess, fr->conn, userinfo, args);
-		} break;
-
-		case 4: { /* ICQ */
-			struct aim_incomingim_ch4_args *args;
-			args = va_arg(ap, struct aim_incomingim_ch4_args *);
-			ret = incomingim_chan4(sess, fr->conn, userinfo, args);
-		} break;
-
-		default: {;
-		} break;
+	case 1: {         /* standard message */
+		struct aim_incomingim_ch1_args *args;
+		args = va_arg(ap, struct aim_incomingim_ch1_args *);
+		ret = incomingim_chan1(sess, fr->conn, userinfo, args);
+	} break;
+
+	case 2: {         /* rendevous */
+		struct aim_incomingim_ch2_args *args;
+		args = va_arg(ap, struct aim_incomingim_ch2_args *);
+		ret = incomingim_chan2(sess, fr->conn, userinfo, args);
+	} break;
+
+	case 4: {         /* ICQ */
+		struct aim_incomingim_ch4_args *args;
+		args = va_arg(ap, struct aim_incomingim_ch4_args *);
+		ret = incomingim_chan4(sess, fr->conn, userinfo, args);
+	} break;
+
+	default: {; } break;
 	}
 
@@ -1213,5 +1281,6 @@
 }
 
-static int gaim_parse_misses(aim_session_t *sess, aim_frame_t *fr, ...) {
+static int gaim_parse_misses(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	guint16 nummissed, reason;
@@ -1221,82 +1290,84 @@
 	va_arg(ap, unsigned int); /* chan */
 	userinfo = va_arg(ap, aim_userinfo_t *);
-	nummissed = (guint16)va_arg(ap, unsigned int);
-	reason = (guint16)va_arg(ap, unsigned int);
+	nummissed = (guint16) va_arg(ap, unsigned int);
+	reason = (guint16) va_arg(ap, unsigned int);
 	va_end(ap);
 
-	switch(reason) {
-		case 0:
-			/* Invalid (0) */
-			imcb_error(sess->aux_data,
-				   nummissed == 1 ? 
-				   _("You missed %d message from %s because it was invalid.") :
-				   _("You missed %d messages from %s because they were invalid."),
-				   nummissed,
-				   userinfo->sn);
-			break;
-		case 1:
-			/* Message too large */
-			imcb_error(sess->aux_data,
-				   nummissed == 1 ?
-				   _("You missed %d message from %s because it was too large.") :
-				   _("You missed %d messages from %s because they were too large."),
-				   nummissed,
-				   userinfo->sn);
-			break;
-		case 2:
-			/* Rate exceeded */
-			imcb_error(sess->aux_data,
-				   nummissed == 1 ? 
-				   _("You missed %d message from %s because the rate limit has been exceeded.") :
-				   _("You missed %d messages from %s because the rate limit has been exceeded."),
-				   nummissed,
-				   userinfo->sn);
-			break;
-		case 3:
-			/* Evil Sender */
-			imcb_error(sess->aux_data,
-				   nummissed == 1 ?
-				   _("You missed %d message from %s because it was too evil.") : 
-				   _("You missed %d messages from %s because they are too evil."),
-				   nummissed,
-				   userinfo->sn);
-			break;
-		case 4:
-			/* Evil Receiver */
-			imcb_error(sess->aux_data,
-				   nummissed == 1 ? 
-				   _("You missed %d message from %s because you are too evil.") :
-				   _("You missed %d messages from %s because you are too evil."),
-				   nummissed,
-				   userinfo->sn);
-			break;
-		default:
-			imcb_error(sess->aux_data,
-				   nummissed == 1 ? 
-				   _("You missed %d message from %s for unknown reasons.") :
-				   _("You missed %d messages from %s for unknown reasons."),
-				   nummissed,
-				   userinfo->sn);
-			break;
-	}
-
-	return 1;
-}
-
-static int gaim_parse_genericerr(aim_session_t *sess, aim_frame_t *fr, ...) {
+	switch (reason) {
+	case 0:
+		/* Invalid (0) */
+		imcb_error(sess->aux_data,
+		           nummissed == 1 ?
+		           _("You missed %d message from %s because it was invalid.") :
+		           _("You missed %d messages from %s because they were invalid."),
+		           nummissed,
+		           userinfo->sn);
+		break;
+	case 1:
+		/* Message too large */
+		imcb_error(sess->aux_data,
+		           nummissed == 1 ?
+		           _("You missed %d message from %s because it was too large.") :
+		           _("You missed %d messages from %s because they were too large."),
+		           nummissed,
+		           userinfo->sn);
+		break;
+	case 2:
+		/* Rate exceeded */
+		imcb_error(sess->aux_data,
+		           nummissed == 1 ?
+		           _("You missed %d message from %s because the rate limit has been exceeded.") :
+		           _("You missed %d messages from %s because the rate limit has been exceeded."),
+		           nummissed,
+		           userinfo->sn);
+		break;
+	case 3:
+		/* Evil Sender */
+		imcb_error(sess->aux_data,
+		           nummissed == 1 ?
+		           _("You missed %d message from %s because it was too evil.") :
+		           _("You missed %d messages from %s because they are too evil."),
+		           nummissed,
+		           userinfo->sn);
+		break;
+	case 4:
+		/* Evil Receiver */
+		imcb_error(sess->aux_data,
+		           nummissed == 1 ?
+		           _("You missed %d message from %s because you are too evil.") :
+		           _("You missed %d messages from %s because you are too evil."),
+		           nummissed,
+		           userinfo->sn);
+		break;
+	default:
+		imcb_error(sess->aux_data,
+		           nummissed == 1 ?
+		           _("You missed %d message from %s for unknown reasons.") :
+		           _("You missed %d messages from %s for unknown reasons."),
+		           nummissed,
+		           userinfo->sn);
+		break;
+	}
+
+	return 1;
+}
+
+static int gaim_parse_genericerr(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	guint16 reason;
 
 	va_start(ap, fr);
-	reason = (guint16)va_arg(ap, unsigned int);
+	reason = (guint16) va_arg(ap, unsigned int);
 	va_end(ap);
 
 	imcb_error(sess->aux_data, _("SNAC threw error: %s"),
-	          reason < msgerrreasonlen ? msgerrreason[reason] : "Unknown error");
-
-	return 1;
-}
-
-static int gaim_parse_msgerr(aim_session_t *sess, aim_frame_t *fr, ...) {
+	           reason < msgerrreasonlen ? msgerrreason[reason] : "Unknown error");
+
+	return 1;
+}
+
+static int gaim_parse_msgerr(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	char *destn;
@@ -1304,15 +1375,16 @@
 
 	va_start(ap, fr);
-	reason = (guint16)va_arg(ap, unsigned int);
+	reason = (guint16) va_arg(ap, unsigned int);
 	destn = va_arg(ap, char *);
 	va_end(ap);
 
 	imcb_error(sess->aux_data, _("Your message to %s did not get sent: %s"), destn,
-			(reason < msgerrreasonlen) ? msgerrreason[reason] : _("Reason unknown"));
-
-	return 1;
-}
-
-static int gaim_parse_locerr(aim_session_t *sess, aim_frame_t *fr, ...) {
+	           (reason < msgerrreasonlen) ? msgerrreason[reason] : _("Reason unknown"));
+
+	return 1;
+}
+
+static int gaim_parse_locerr(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	char *destn;
@@ -1320,82 +1392,86 @@
 
 	va_start(ap, fr);
-	reason = (guint16)va_arg(ap, unsigned int);
+	reason = (guint16) va_arg(ap, unsigned int);
 	destn = va_arg(ap, char *);
 	va_end(ap);
 
 	imcb_error(sess->aux_data, _("User information for %s unavailable: %s"), destn,
-			(reason < msgerrreasonlen) ? msgerrreason[reason] : _("Reason unknown"));
-
-	return 1;
-}
-
-static int gaim_parse_motd(aim_session_t *sess, aim_frame_t *fr, ...) {
+	           (reason < msgerrreasonlen) ? msgerrreason[reason] : _("Reason unknown"));
+
+	return 1;
+}
+
+static int gaim_parse_motd(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	guint16 id;
 	va_list ap;
 
 	va_start(ap, fr);
-	id  = (guint16)va_arg(ap, unsigned int);
+	id  = (guint16) va_arg(ap, unsigned int);
 	va_arg(ap, char *); /* msg */
 	va_end(ap);
 
-	if (id < 4)
+	if (id < 4) {
 		imcb_error(sess->aux_data, _("Your connection may be lost."));
-
-	return 1;
-}
-
-static int gaim_chatnav_info(aim_session_t *sess, aim_frame_t *fr, ...) {
+	}
+
+	return 1;
+}
+
+static int gaim_chatnav_info(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	guint16 type;
 	struct im_connection *ic = sess->aux_data;
-	struct oscar_data *odata = (struct oscar_data *)ic->proto_data;
+	struct oscar_data *odata = (struct oscar_data *) ic->proto_data;
 
 	va_start(ap, fr);
-	type = (guint16)va_arg(ap, unsigned int);
-
-	switch(type) {
-		case 0x0002: {
-			va_arg(ap, unsigned int); /* maxrooms */
-			va_arg(ap, int); /* exchangecount */
-			va_arg(ap, struct aim_chat_exchangeinfo *); /* exchanges */
-			va_end(ap);
-
-			while (odata->create_rooms) {
-				struct create_room *cr = odata->create_rooms->data;
-				aim_chatnav_createroom(sess, fr->conn, cr->name, cr->exchange);
-				g_free(cr->name);
-				odata->create_rooms = g_slist_remove(odata->create_rooms, cr);
-				g_free(cr);
-			}
-			}
-			break;
-		case 0x0008: {
-			char *ck;
-			guint16 instance, exchange;
-
-			va_arg(ap, char *); /* fqcn */
-			instance = (guint16)va_arg(ap, unsigned int);
-			exchange = (guint16)va_arg(ap, unsigned int);
-			va_arg(ap, unsigned int); /* flags */
-			va_arg(ap, guint32); /* createtime */
-			va_arg(ap, unsigned int); /* maxmsglen */
-			va_arg(ap, unsigned int); /* maxoccupancy */
-			va_arg(ap, int); /* createperms */
-			va_arg(ap, unsigned int); /* unknown */
-			va_arg(ap, char *); /* name */
-			ck = va_arg(ap, char *);
-			va_end(ap);
-
-			aim_chat_join(odata->sess, odata->conn, exchange, ck, instance);
-			}
-			break;
-		default:
-			va_end(ap);
-			break;
-	}
-	return 1;
-}
-
-static int gaim_chat_join(aim_session_t *sess, aim_frame_t *fr, ...) {
+	type = (guint16) va_arg(ap, unsigned int);
+
+	switch (type) {
+	case 0x0002: {
+		va_arg(ap, unsigned int);         /* maxrooms */
+		va_arg(ap, int);         /* exchangecount */
+		va_arg(ap, struct aim_chat_exchangeinfo *);         /* exchanges */
+		va_end(ap);
+
+		while (odata->create_rooms) {
+			struct create_room *cr = odata->create_rooms->data;
+			aim_chatnav_createroom(sess, fr->conn, cr->name, cr->exchange);
+			g_free(cr->name);
+			odata->create_rooms = g_slist_remove(odata->create_rooms, cr);
+			g_free(cr);
+		}
+	}
+	break;
+	case 0x0008: {
+		char *ck;
+		guint16 instance, exchange;
+
+		va_arg(ap, char *);         /* fqcn */
+		instance = (guint16) va_arg(ap, unsigned int);
+		exchange = (guint16) va_arg(ap, unsigned int);
+		va_arg(ap, unsigned int);         /* flags */
+		va_arg(ap, guint32);         /* createtime */
+		va_arg(ap, unsigned int);         /* maxmsglen */
+		va_arg(ap, unsigned int);         /* maxoccupancy */
+		va_arg(ap, int);         /* createperms */
+		va_arg(ap, unsigned int);         /* unknown */
+		va_arg(ap, char *);         /* name */
+		ck = va_arg(ap, char *);
+		va_end(ap);
+
+		aim_chat_join(odata->sess, odata->conn, exchange, ck, instance);
+	}
+	break;
+	default:
+		va_end(ap);
+		break;
+	}
+	return 1;
+}
+
+static int gaim_chat_join(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	int count, i;
@@ -1411,14 +1487,17 @@
 
 	c = find_oscar_chat_by_conn(g, fr->conn);
-	if (!c)
+	if (!c) {
 		return 1;
-
-	for (i = 0; i < count; i++)
+	}
+
+	for (i = 0; i < count; i++) {
 		imcb_chat_add_buddy(c->cnv, normalize(info[i].sn));
-
-	return 1;
-}
-
-static int gaim_chat_leave(aim_session_t *sess, aim_frame_t *fr, ...) {
+	}
+
+	return 1;
+}
+
+static int gaim_chat_leave(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	int count, i;
@@ -1434,14 +1513,17 @@
 
 	c = find_oscar_chat_by_conn(g, fr->conn);
-	if (!c)
+	if (!c) {
 		return 1;
-
-	for (i = 0; i < count; i++)
+	}
+
+	for (i = 0; i < count; i++) {
 		imcb_chat_remove_buddy(c->cnv, normalize(info[i].sn), NULL);
-
-	return 1;
-}
-
-static int gaim_chat_info_update(aim_session_t *sess, aim_frame_t *fr, ...) {
+	}
+
+	return 1;
+}
+
+static int gaim_chat_info_update(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	guint16 maxmsglen, maxvisiblemsglen;
@@ -1457,8 +1539,8 @@
 	va_arg(ap, int); /* unknown_c9 */
 	va_arg(ap, unsigned long); /* creationtime */
-	maxmsglen = (guint16)va_arg(ap, int);
+	maxmsglen = (guint16) va_arg(ap, int);
 	va_arg(ap, int); /* unknown_d2 */
 	va_arg(ap, int); /* unknown_d5 */
-	maxvisiblemsglen = (guint16)va_arg(ap, int);
+	maxvisiblemsglen = (guint16) va_arg(ap, int);
 	va_end(ap);
 
@@ -1469,5 +1551,6 @@
 }
 
-static int gaim_chat_incoming_msg(aim_session_t *sess, aim_frame_t *fr, ...) {
+static int gaim_chat_incoming_msg(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	aim_userinfo_t *info;
@@ -1489,12 +1572,13 @@
 }
 
-static int gaim_parse_ratechange(aim_session_t *sess, aim_frame_t *fr, ...) {
+static int gaim_parse_ratechange(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 #if 0
 	static const char *codes[5] = {
 		"invalid",
-		 "change",
-		 "warning",
-		 "limit",
-		 "limit cleared",
+		"change",
+		"warning",
+		"limit",
+		"limit cleared",
 	};
 #endif
@@ -1503,13 +1587,13 @@
 	guint32 windowsize, clear, currentavg;
 
-	va_start(ap, fr); 
-	code = (guint16)va_arg(ap, unsigned int);
+	va_start(ap, fr);
+	code = (guint16) va_arg(ap, unsigned int);
 	va_arg(ap, unsigned int); /* rateclass */
-	windowsize = (guint32)va_arg(ap, unsigned long);
-	clear = (guint32)va_arg(ap, unsigned long);
+	windowsize = (guint32) va_arg(ap, unsigned long);
+	clear = (guint32) va_arg(ap, unsigned long);
 	va_arg(ap, unsigned long); /* alert */
 	va_arg(ap, unsigned long); /* limit */
 	va_arg(ap, unsigned long); /* disconnect */
-	currentavg = (guint32)va_arg(ap, unsigned long);
+	currentavg = (guint32) va_arg(ap, unsigned long);
 	va_arg(ap, unsigned long); /* maxavg */
 	va_end(ap);
@@ -1517,12 +1601,13 @@
 	/* XXX fix these values */
 	if (code == AIM_RATE_CODE_CHANGE) {
-		if (currentavg >= clear)
+		if (currentavg >= clear) {
 			aim_conn_setlatency(fr->conn, 0);
+		}
 	} else if (code == AIM_RATE_CODE_WARNING) {
-		aim_conn_setlatency(fr->conn, windowsize/4);
+		aim_conn_setlatency(fr->conn, windowsize / 4);
 	} else if (code == AIM_RATE_CODE_LIMIT) {
 		imcb_error(sess->aux_data, _("The last message was not sent because you are over the rate limit. "
-			  "Please wait 10 seconds and try again."));
-		aim_conn_setlatency(fr->conn, windowsize/2);
+		                             "Please wait 10 seconds and try again."));
+		aim_conn_setlatency(fr->conn, windowsize / 2);
 	} else if (code == AIM_RATE_CODE_CLEARLIMIT) {
 		aim_conn_setlatency(fr->conn, 0);
@@ -1532,9 +1617,11 @@
 }
 
-static int gaim_selfinfo(aim_session_t *sess, aim_frame_t *fr, ...) {
-	return 1;
-}
-
-static int conninitdone_bos(aim_session_t *sess, aim_frame_t *fr, ...) {
+static int gaim_selfinfo(aim_session_t *sess, aim_frame_t *fr, ...)
+{
+	return 1;
+}
+
+static int conninitdone_bos(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 
 	aim_reqpersonalinfo(sess, fr->conn);
@@ -1547,10 +1634,11 @@
 	aim_bos_setgroupperm(sess, fr->conn, AIM_FLAG_ALLUSERS);
 	aim_bos_setprivacyflags(sess, fr->conn, AIM_PRIVFLAGS_ALLOWIDLE |
-						     AIM_PRIVFLAGS_ALLOWMEMBERSINCE);
-
-	return 1;
-}
-
-static int conninitdone_admin(aim_session_t *sess, aim_frame_t *fr, ...) {
+	                        AIM_PRIVFLAGS_ALLOWMEMBERSINCE);
+
+	return 1;
+}
+
+static int conninitdone_admin(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	struct im_connection *ic = sess->aux_data;
 	struct oscar_data *od = ic->proto_data;
@@ -1589,5 +1677,6 @@
 }
 
-static int gaim_icbm_param_info(aim_session_t *sess, aim_frame_t *fr, ...) {
+static int gaim_icbm_param_info(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	struct aim_icbmparameters *params;
 	va_list ap;
@@ -1612,5 +1701,5 @@
 	guint16 maxsiglen;
 	struct im_connection *ic = sess->aux_data;
-	struct oscar_data *odata = (struct oscar_data *)ic->proto_data;
+	struct oscar_data *odata = (struct oscar_data *) ic->proto_data;
 
 	va_start(ap, fr);
@@ -1618,5 +1707,5 @@
 	va_end(ap);
 
-	odata->rights.maxsiglen = odata->rights.maxawaymsglen = (guint)maxsiglen;
+	odata->rights.maxsiglen = odata->rights.maxawaymsglen = (guint) maxsiglen;
 
 	/* FIXME: It seems we're not really using this, and it broke now that
@@ -1624,38 +1713,40 @@
 	aim_bos_setprofile(sess, fr->conn, ic->user->user_info, NULL, gaim_caps);
 	*/
-	
-	return 1;
-}
-
-static int gaim_parse_buddyrights(aim_session_t *sess, aim_frame_t *fr, ...) {
+
+	return 1;
+}
+
+static int gaim_parse_buddyrights(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	guint16 maxbuddies, maxwatchers;
 	struct im_connection *ic = sess->aux_data;
-	struct oscar_data *odata = (struct oscar_data *)ic->proto_data;
+	struct oscar_data *odata = (struct oscar_data *) ic->proto_data;
 
 	va_start(ap, fr);
-	maxbuddies = (guint16)va_arg(ap, unsigned int);
-	maxwatchers = (guint16)va_arg(ap, unsigned int);
+	maxbuddies = (guint16) va_arg(ap, unsigned int);
+	maxwatchers = (guint16) va_arg(ap, unsigned int);
 	va_end(ap);
 
-	odata->rights.maxbuddies = (guint)maxbuddies;
-	odata->rights.maxwatchers = (guint)maxwatchers;
-
-	return 1;
-}
-
-static int gaim_bosrights(aim_session_t *sess, aim_frame_t *fr, ...) {
+	odata->rights.maxbuddies = (guint) maxbuddies;
+	odata->rights.maxwatchers = (guint) maxwatchers;
+
+	return 1;
+}
+
+static int gaim_bosrights(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	guint16 maxpermits, maxdenies;
 	va_list ap;
 	struct im_connection *ic = sess->aux_data;
-	struct oscar_data *odata = (struct oscar_data *)ic->proto_data;
+	struct oscar_data *odata = (struct oscar_data *) ic->proto_data;
 
 	va_start(ap, fr);
-	maxpermits = (guint16)va_arg(ap, unsigned int);
-	maxdenies = (guint16)va_arg(ap, unsigned int);
+	maxpermits = (guint16) va_arg(ap, unsigned int);
+	maxdenies = (guint16) va_arg(ap, unsigned int);
 	va_end(ap);
 
-	odata->rights.maxpermits = (guint)maxpermits;
-	odata->rights.maxdenies = (guint)maxdenies;
+	odata->rights.maxpermits = (guint) maxpermits;
+	odata->rights.maxdenies = (guint) maxdenies;
 
 	aim_clientready(sess, fr->conn);
@@ -1669,5 +1760,6 @@
 }
 
-static int gaim_offlinemsg(aim_session_t *sess, aim_frame_t *fr, ...) {
+static int gaim_offlinemsg(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	va_list ap;
 	struct aim_icq_offlinemsg *msg;
@@ -1679,54 +1771,57 @@
 
 	switch (msg->type) {
-		case 0x0001: { /* Basic offline message */
-			char sender[32];
-			char *dialog_msg = g_strdup(msg->msg);
-			time_t t = get_time(msg->year, msg->month, msg->day, msg->hour, msg->minute, 0);
-			g_snprintf(sender, sizeof(sender), "%u", msg->sender);
-			strip_linefeed(dialog_msg);
-			imcb_buddy_msg(ic, normalize(sender), dialog_msg, 0, t);
-			g_free(dialog_msg);
-		} break;
-
-		case 0x0004: { /* Someone sent you a URL */
-		  	char sender[32];
-		  	char *dialog_msg;
-			char **m;
-
-			time_t t = get_time(msg->year, msg->month, msg->day, msg->hour, msg->minute, 0);
-			g_snprintf(sender, sizeof(sender), "%u", msg->sender);
-
-			m = g_strsplit(msg->msg, "\376", 2);
-
-			if ((strlen(m[0]) != 0)) {
-			  dialog_msg = g_strjoinv(" -- ", m);
-			} else {
-			  dialog_msg = m[1];
-			}
-
-			strip_linefeed(dialog_msg);
-			imcb_buddy_msg(ic, normalize(sender), dialog_msg, 0, t);
-			g_free(dialog_msg);
-			g_free(m);
-		} break;
-		
-		case 0x0006: { /* Authorization request */
-			gaim_icq_authask(ic, msg->sender, msg->msg);
-		} break;
-
-		case 0x0007: { /* Someone has denied you authorization */
-			imcb_log(sess->aux_data, "The user %u has denied your request to add them to your contact list for the following reason:\n%s", msg->sender, msg->msg ? msg->msg : _("No reason given.") );
-		} break;
-
-		case 0x0008: { /* Someone has granted you authorization */
-			imcb_log(sess->aux_data, "The user %u has granted your request to add them to your contact list for the following reason:\n%s", msg->sender, msg->msg ? msg->msg : _("No reason given.") );
-		} break;
-
-		case 0x0012: {
-			/* Ack for authorizing/denying someone.  Or possibly an ack for sending any system notice */
-		} break;
-
-		default: {;
-		}
+	case 0x0001: {         /* Basic offline message */
+		char sender[32];
+		char *dialog_msg = g_strdup(msg->msg);
+		time_t t = get_time(msg->year, msg->month, msg->day, msg->hour, msg->minute, 0);
+		g_snprintf(sender, sizeof(sender), "%u", msg->sender);
+		strip_linefeed(dialog_msg);
+		imcb_buddy_msg(ic, normalize(sender), dialog_msg, 0, t);
+		g_free(dialog_msg);
+	} break;
+
+	case 0x0004: {         /* Someone sent you a URL */
+		char sender[32];
+		char *dialog_msg;
+		char **m;
+
+		time_t t = get_time(msg->year, msg->month, msg->day, msg->hour, msg->minute, 0);
+		g_snprintf(sender, sizeof(sender), "%u", msg->sender);
+
+		m = g_strsplit(msg->msg, "\376", 2);
+
+		if ((strlen(m[0]) != 0)) {
+			dialog_msg = g_strjoinv(" -- ", m);
+		} else {
+			dialog_msg = m[1];
+		}
+
+		strip_linefeed(dialog_msg);
+		imcb_buddy_msg(ic, normalize(sender), dialog_msg, 0, t);
+		g_free(dialog_msg);
+		g_free(m);
+	} break;
+
+	case 0x0006: {         /* Authorization request */
+		gaim_icq_authask(ic, msg->sender, msg->msg);
+	} break;
+
+	case 0x0007: {         /* Someone has denied you authorization */
+		imcb_log(sess->aux_data,
+		         "The user %u has denied your request to add them to your contact list for the following reason:\n%s", msg->sender,
+		         msg->msg ? msg->msg : _("No reason given."));
+	} break;
+
+	case 0x0008: {         /* Someone has granted you authorization */
+		imcb_log(sess->aux_data,
+		         "The user %u has granted your request to add them to your contact list for the following reason:\n%s", msg->sender,
+		         msg->msg ? msg->msg : _("No reason given."));
+	} break;
+
+	case 0x0012: {
+		/* Ack for authorizing/denying someone.  Or possibly an ack for sending any system notice */
+	} break;
+
+	default: {; }
 	}
 
@@ -1740,12 +1835,16 @@
 }
 
-static void oscar_keepalive(struct im_connection *ic) {
-	struct oscar_data *odata = (struct oscar_data *)ic->proto_data;
+static void oscar_keepalive(struct im_connection *ic)
+{
+	struct oscar_data *odata = (struct oscar_data *) ic->proto_data;
+
 	aim_flap_nop(odata->sess, odata->conn);
 }
 
-static int oscar_buddy_msg(struct im_connection *ic, char *name, char *message, int imflags) {
-	struct oscar_data *odata = (struct oscar_data *)ic->proto_data;
+static int oscar_buddy_msg(struct im_connection *ic, char *name, char *message, int imflags)
+{
+	struct oscar_data *odata = (struct oscar_data *) ic->proto_data;
 	int ret = 0, len = strlen(message);
+
 	if (imflags & OPT_AWAY) {
 		ret = aim_send_im(odata->sess, name, AIM_IMFLAGS_AWAY, message);
@@ -1753,12 +1852,15 @@
 		struct aim_sendimext_args args;
 		char *s;
-		
+
 		args.flags = AIM_IMFLAGS_ACK;
-		if (odata->icq)
+		if (odata->icq) {
 			args.flags |= AIM_IMFLAGS_OFFLINE;
-		for (s = message; *s; s++)
-			if (*s & 128)
+		}
+		for (s = message; *s; s++) {
+			if (*s & 128) {
 				break;
-		
+			}
+		}
+
 		/* Message contains high ASCII chars, time for some translation! */
 		if (*s) {
@@ -1774,5 +1876,5 @@
 			} else {
 				/* OOF, translation failed... Oh well.. */
-				g_free( s );
+				g_free(s);
 				s = message;
 			}
@@ -1780,28 +1882,31 @@
 			s = message;
 		}
-		
+
 		args.features = gaim_features;
 		args.featureslen = sizeof(gaim_features);
-		
+
 		args.destsn = name;
 		args.msg    = s;
 		args.msglen = len;
-		
+
 		ret = aim_send_im_ext(odata->sess, &args);
-		
+
 		if (s != message) {
 			g_free(s);
 		}
 	}
-	if (ret >= 0)
+	if (ret >= 0) {
 		return 1;
+	}
 	return ret;
 }
 
-static void oscar_get_info(struct im_connection *g, char *name) {
-	struct oscar_data *odata = (struct oscar_data *)g->proto_data;
-	if (odata->icq)
+static void oscar_get_info(struct im_connection *g, char *name)
+{
+	struct oscar_data *odata = (struct oscar_data *) g->proto_data;
+
+	if (odata->icq) {
 		aim_icq_getallinfo(odata->sess, name);
-	else {
+	} else {
 		aim_getinfo(odata->sess, odata->conn, name, AIM_GETINFO_AWAYMESSAGE);
 		aim_getinfo(odata->sess, odata->conn, name, AIM_GETINFO_GENERALINFO);
@@ -1809,22 +1914,26 @@
 }
 
-static void oscar_get_away(struct im_connection *g, char *who) {
-	struct oscar_data *odata = (struct oscar_data *)g->proto_data;
+static void oscar_get_away(struct im_connection *g, char *who)
+{
+	struct oscar_data *odata = (struct oscar_data *) g->proto_data;
+
 	if (odata->icq) {
 		/** FIXME(wilmer): Hmm, lost the ability to get away msgs here, do we care to get that back?
 		struct buddy *budlight = imcb_find_buddy(g, who);
 		if (budlight)
-			if ((budlight->uc & 0xff80) >> 7)
-				if (budlight->caps & AIM_CAPS_ICQSERVERRELAY)
-					aim_send_im_ch2_geticqmessage(odata->sess, who, (budlight->uc & 0xff80) >> 7);
+		        if ((budlight->uc & 0xff80) >> 7)
+		                if (budlight->caps & AIM_CAPS_ICQSERVERRELAY)
+		                        aim_send_im_ch2_geticqmessage(odata->sess, who, (budlight->uc & 0xff80) >> 7);
 		*/
-	} else
+	} else {
 		aim_getinfo(odata->sess, odata->conn, who, AIM_GETINFO_AWAYMESSAGE);
+	}
 }
 
 static void oscar_set_away_aim(struct im_connection *ic, struct oscar_data *od, const char *state, const char *message)
 {
-	if (state == NULL)
+	if (state == NULL) {
 		state = "";
+	}
 
 	if (!g_strcasecmp(state, _("Visible"))) {
@@ -1838,6 +1947,7 @@
 	}
 
-	if (od->rights.maxawaymsglen == 0)
+	if (od->rights.maxawaymsglen == 0) {
 		imcb_error(ic, "oscar_set_away_aim called before locate rights received");
+	}
 
 	aim_setextstatus(od->sess, od->conn, AIM_ICQ_STATE_NORMAL);
@@ -1852,5 +1962,6 @@
 
 	if (strlen(message) > od->rights.maxawaymsglen) {
-		imcb_error(ic, "Maximum away message length of %d bytes exceeded, truncating", od->rights.maxawaymsglen);
+		imcb_error(ic, "Maximum away message length of %d bytes exceeded, truncating",
+		           od->rights.maxawaymsglen);
 	}
 
@@ -1905,5 +2016,5 @@
 		ic->away = g_strdup(msg);
 	} else {
-	 	if (no_message) {
+		if (no_message) {
 			aim_setextstatus(od->sess, od->conn, AIM_ICQ_STATE_NORMAL);
 		} else {
@@ -1919,34 +2030,46 @@
 static void oscar_set_away(struct im_connection *ic, char *state, char *message)
 {
-	struct oscar_data *od = (struct oscar_data *)ic->proto_data;
+	struct oscar_data *od = (struct oscar_data *) ic->proto_data;
 
 	oscar_set_away_aim(ic, od, state, message);
-	if (od->icq)
+	if (od->icq) {
 		oscar_set_away_icq(ic, od, state, message);
+	}
 
 	return;
 }
 
-static void oscar_add_buddy(struct im_connection *g, char *name, char *group) {
-	struct oscar_data *odata = (struct oscar_data *)g->proto_data;
+static void oscar_add_buddy(struct im_connection *g, char *name, char *group)
+{
+	struct oscar_data *odata = (struct oscar_data *) g->proto_data;
 	bee_user_t *bu;
-	
-	if (group && (bu = bee_user_by_handle(g->bee, g, name)) && bu->group)
+
+	if (group && (bu = bee_user_by_handle(g->bee, g, name)) && bu->group) {
 		aim_ssi_movebuddy(odata->sess, odata->conn, bu->group->name, group, name);
-	else
+	} else {
 		aim_ssi_addbuddies(odata->sess, odata->conn, group ? : OSCAR_GROUP, &name, 1, 0);
-}
-
-static void oscar_remove_buddy(struct im_connection *g, char *name, char *group) {
-	struct oscar_data *odata = (struct oscar_data *)g->proto_data;
+	}
+}
+
+static void oscar_remove_buddy(struct im_connection *g, char *name, char *group)
+{
+	struct oscar_data *odata = (struct oscar_data *) g->proto_data;
 	struct aim_ssi_item *ssigroup;
-	while ((ssigroup = aim_ssi_itemlist_findparent(odata->sess->ssi.items, name)) && !aim_ssi_delbuddies(odata->sess, odata->conn, ssigroup->name, &name, 1));
-}
-
-static int gaim_ssi_parserights(aim_session_t *sess, aim_frame_t *fr, ...) {
-	return 1;
-}
-
-static int gaim_ssi_parselist(aim_session_t *sess, aim_frame_t *fr, ...) {
+
+	while ((ssigroup =
+	                aim_ssi_itemlist_findparent(odata->sess->ssi.items,
+	                                            name)) &&
+	       !aim_ssi_delbuddies(odata->sess, odata->conn, ssigroup->name, &name, 1)) {
+		;
+	}
+}
+
+static int gaim_ssi_parserights(aim_session_t *sess, aim_frame_t *fr, ...)
+{
+	return 1;
+}
+
+static int gaim_ssi_parselist(aim_session_t *sess, aim_frame_t *fr, ...)
+{
 	struct im_connection *ic = sess->aux_data;
 	struct aim_ssi_item *curitem, *curgroup = NULL;
